<template>
  <div class="content">
    <subjects-table @subject-selected="subjectSelected"></subjects-table>
    <div class="newStudent">
      <h4 v-if="isAdding">Add New Subject</h4>
      <h4 v-else>Edit Existing Subject</h4>
      <hr>
      <div class="newStudentForm">
          <label class="formLabel">Subject Name</label>
          <input type="text" placeholder="Subject Name" v-model="newSubject.name">
          <label class="formLabel">Token</label>
          <input type="text" placeholder="Subject Token" v-model="newSubject.token"> 
          <input type="submit" class="newStudentSubmit" :value="isAdding ? 'ADD' : 'UPDATE'" @click="saveSubject()">
          <input v-show="isEditing" type="submit" class="newStudentSubmit" value="ADD NEW" @click="openAdd()">

          <div v-show="isSuccessfullyAdded" class="notify">
              <p>Subject has been succesfully added</p>
          </div>
      </div>
    </div>
  </div>
  <!--div>
    <subjects-commands :selectedSubject="selectedSubject" @edit-pressed="openEdit" @add-pressed="openAdd"></subjects-commands>
    <div v-show="isAddOrEditOn" class="add-new-form">
      <button @click="saveSubject()">Save</button>
      <button @click="cancel()">Cancel</button>
      <input  placeholder="Name" 
                          :class="{required: (newSubject.name === '' && check)}"
                          v-model="newSubject.name" required>
      <input  placeholder="Token" 
                          :class="{required: (newSubject.token === '' && check)}"
                          v-model="newSubject.token" required>
    </div>
    <subjects-table :selectedSubject="selectedSubject" @subject-selected="subjectSelected"></subjects-table>
  </div>-->
</template>

<script>
import store from '../../store/store.js'
import axios from 'axios'
import SubjectsCommands from './SubjectsCommands.vue'
import SubjectsTable from './SubjectsTable.vue'
import {mapGetters} from 'vuex'

export default {
  data () {
    return {
      selectedSubject: null,
      newSubject: {
        id: '',
        name: '',
        token: '',
      },
      check: false,
      isAdding: true,
      isEditing: false,
      isSuccessfullyAdded: false
    }
  },
  methods: {
    subjectSelected(subject) {
      this.selectedSubject = subject;
      this.openEdit();
    },

    openEdit () {
      this.isSuccessfullyAdded = false;
      this.isEditing = true;
      this.isAdding = false;
      this.newSubject = JSON.parse(JSON.stringify(this.selectedSubject));
    },
    
    openAdd () {
      this.isSuccessfullyAdded = false;
      this.isAdding = true;
      this.isEditing = false;
      this.clearFields();
    },
    cancel () {
      this.isAdding = false;
      this.isEditing = false; 
      this.clearFields();
    },
    clearFields () {
      this.newSubject = {
        id: '',
        name: '',
        token: '',
      };
    },
    saveSubject () {
      if (this.isAdding)
        this.addSubject();
      if (this.isEditing)
        this.editSubject();
    },
    addSubject () {
      delete this.newSubject.id;
      var vm = this;
      axios.post(this.server + '/subject', JSON.stringify(this.newSubject))
      .then(function (response) {
        // console.log(response);
        // vm.updateSubjects(); 
        this.isSuccessfullyAdded = true;
        vm.$emit('updateSubjects');
      }.bind(this))
      .catch((error) => {
        console.log(error);
        // vm.errors = []
        // vm.errors.push(error.response.data.error)
      });
    },
    editSubject () {
      var vm = this;
      axios.put(this.server + '/subject/' + this.newSubject.id, JSON.stringify(this.newSubject))
      .then(function (response) {
        // console.log(response);
        // vm.updateSubjects(); 
        this.isSuccessfullyAdded = true;
        vm.$emit('updateSubjects');
      }.bind(this))
      .catch((error) => {
        console.log(error.code);
        // if(error.response.data.error)
        // vm.errors = []
        // vm.errors.push(error.response.data.error)
      });
    }
  },
  computed: {
    ...mapGetters([
      'server'
    ]),
    isAddOrEditOn () {
      return this.isAdding || this.isEditing;
    }
  },
  components: {
    "subjects-commands": SubjectsCommands,
    "subjects-table": SubjectsTable
  }
}
</script>

<style lang="scss">
div.add-new-form {
  float: left;
  width: 75%;
  height: 10%;
  margin-left: 4%;

  input {
    width: 20%;
  }
}
</style>